***   INFO.PRG
***   INFORMACNI SYSTEM A DATABAZE INFORMACI (v) 2.0,
***   TENTO SYSTEM OBSLOUZI NEKOLIK DATABAZI RUZNYCH INFORMACI,
***   HLAVNI PROGRAM, (c)1999/09JH,9.9.1999,
*----------------------------------------------------------*
* - 1.par. PR_ZDR - ZDROJOVY ADRESAR - umisteni zpracovavanych dat,
* - 2.par. PR_PRC - PRACOVNI ADRESAR - umisteni programu,
*   tyto 2 parametry jsou povinne, (vlastni data jsou v PR_PRC+"DATA\")
* - 3.par. PR_JMZ - JMENO ZDROJE DAT - jeden ze souboru informaci,
*   lezi v miste programu PR_PRC+"DATA\" - povinny,
* - 4.par. PR_PUS - MAX.POCET ULOZENYCH TISKOVYCH SESTAV, povinny,
* - 5.par. PR_HES - HESLO PRO SPEC. AKCE - prikazy, max.10, povinny,
* - 6.par. PR_COL - BARVY - M mono, C1 barva1-standard, povinny,
*----------------------------------------------------------*
* - urceno pro spravce, 
* - rucni spousteni, spousti jednotlive podprogramy INFOxx.PRG,
* - zurnal smerovany do souboru INFO.ZUR v pracovnim adresari PR_PRC,
*   ( pro zurnal > 20 KB se provede jeho zaloha do INFO.ZZU a puvodni
*    zurnal se vynuluje - zrusi a jeho plneni zapocne znovu od nuly ) 
*----------------------------------------------------------*
*----------------------------------------------------------*
*   nacteni 6 vnejsich parametru, nastaveni prostredi, osetreni chyb
para PR_ZDR,PR_PRC,PR_JMZ,PR_PUS,PR_HES,PR_COL
  clea
  =SETY(.t.)
  on erro do CHYBA with erro(),mess(),mess(1),line(),prog()
  =BARVA()
  *-----*
  *   test povinnych parametru,
  *-----*
  if empt(PR_ZDR) or empt(PR_PRC) or empt(PR_JMZ) ;
  or empt(PR_PUS) or empt(PR_HES) or empt(PR_COL)
    ? repl("=",3)+" START, "+DTOC(DATE())+", "+TIME()+;
    ", INFO.EXE (v) 2.0 "+repl("=",18)
    ? " * CHYBA 001 - Spusteno bez vnejsich parametru." +space(21)
    ? repl("=",3)+" KONEC, "+DTOC(DATE())+", "+TIME()+" "+repl("=",36)
    wait "" time 99
  else
    if file(PR_ZDR+"DATA\"+PR_JMZ+".DBF")
      save to (PR_PRC+"INFO") all like PR_*
      do HLAVNI
    else
      ? repl("=",3)+" START, "+DTOC(DATE())+", "+TIME()+;
      ", INFO.EXE (v) 2.0 "+repl("=",18)
      ? " * CHYBA 002 - Soubor "+PR_ZDR+"DATA\"+PR_JMZ+".DBF NEEXISTUJE."
      ? repl("=",3)+" KONEC, "+DTOC(DATE())+", "+TIME()+" "+repl("=",36)
      wait "" time 99
    endi
  endi
  =BARVA("KO")
  =SETY(.f.)
  clos data
  clea all
  clea
  on erro
canc
*----------------------------------------------------------*
*----------------------------------------------------------*
**********
*   HLAVNI - hlavni program - menu - zakladni obrazovka
**********
proc HLAVNI
  *-----*
  *   globalni promenne
  *   tim ze jsou promenne zde v hlavnim prg - jsou vsude pristupne
  *-----*
  * - me_kon - je nadefinovana jiz ve vyssi urovni v hlavni procedure
  *   HLAVNI v cyklu SMHES pro osetreni nezobrazeni hesla 
  *   pri zaverecnem ukonceni celeho programu INFO
  *-----*
  ME_KON=0
  *-----*
  defi menu HLAVNI
  defi pad DATA of HLAVNI prom "\<Data" at 2,1 mess " Zobrazeni, "+ ;
  "opravy, vkladani, ruseni, reindexace, kontrola dat. "
  defi pad NASTROJE of HLAVNI prom "\<Nastroje" at 2,7 mess ;
  " Podpurne nastroje, nastaveni, specialni cinnosti. "
  defi pad NAPOVEDA of HLAVNI prom "\<Program" at 2,17 mess ;
  " Informace o verzi programu. "
  defi pad UKONCENI of HLAVNI prom "\<Ukonceni" at 2,69 mess ;
  " Ukonceni programu. "
  on sele pad DATA     of HLAVNI acti popu DATA
  on sele pad NASTROJE of HLAVNI acti popu NASTROJE
  on sele pad NAPOVEDA of HLAVNI do NAPOVEDA
  on sele pad UKONCENI of HLAVNI do UKONCENI
  *-----*
  defi popu DATA from 3,1 shad
  defi bar 1  of DATA prom " Zobrazeni dat \<1 " mess ;
  " Zobrazeni 1 + opravy, vkladani, ruseni dat nastavene databaze. "
  defi bar 2  of DATA prom " Zobrazeni dat \<2 " mess ;
  " Zobrazeni 2 + opravy, vkladani, ruseni dat nastavene databaze. "
  defi bar 3  of DATA prom "\-"
  defi bar 4  of DATA prom " \<Reindexovani  " mess ;
  " Rekonstrukce indexovych souboru nastavene databaze. "
  defi bar 5  of DATA prom " \<Kontrola dat " mess ;
  " Kontrola konzistence a spravneho zapsani dat. "
  on sele popu DATA do HL_AKCE with pad(),bar()
  *-----*
  defi popu NASTROJE from 3,7 shad
  defi bar 1  of NASTROJE prom " \<Tiskovy manazer   " mess ;
  " Udrzovani ulozenych tiskovych sestav "+;
  "( opakovany tisk, upravy sestav,...). "
  defi bar 2  of NASTROJE prom " \<Nastaveni zdroje " mess ;
  " Nastaveni databaze informaci jako aktualniho zdroje dat. "
  defi bar 3  of NASTROJE prom " \<Zalohovani dat   " mess ;
  " Pracovni zalohovani dat na vybrany disk, adresar nebo disketu. "
  defi bar 4  of NASTROJE prom " \<Archivovani dat   " mess ;
  " Archivovani predem oznacenych dlouhodobe nepouzivanych dat. "
  defi bar 5  of NASTROJE prom "\-"
  defi bar 6  of NASTROJE prom " St\<ruktura tabulky " mess ;
  " Vygenerovani prazdne tabulky INFOVZOR.DBF se spravnou strukturou. "
  defi bar 7  of NASTROJE prom " \<Specialni akce... " mess ;
  " Specialni akce - spousteni prikazu MS-DOSu nebo externich programu. "
  on sele popu NASTROJE do HL_AKCE with pad(),bar()
  *-----*
  *   nacteni jmena zdroje z pametoveho pracovniho souboru existuje-li
  *-----*
  if file(PR_PRC+"INFO.MEM")
    rest from (PR_PRC+"INFO") addi
    *-----*
    if !empt(PR_JMZ)
      if len(PR_ZDR) > 23
        RAD_0 = "Zdroj dat [ "+ uppe(allt(left(PR_ZDR,3)))+ " ... "+ ;
        uppe(allt(righ(PR_ZDR,14)))+ "DATA\"+;
        uppe(allt(PR_JMZ)) +".DBF ]"
      else
        RAD_0 = "Zdroj dat [ "+ uppe(allt(PR_ZDR))+ "DATA\"+;
        uppe(allt(PR_JMZ)) +".DBF ]"
      endi
    else
      RAD_0 = ">> NENI nastaven zdroj dat. Prosim NASTAVTE zdroj. <<"
      @ 0,0 say RAD_0 colo R*/W
    endi
  else
    RAD_0 = ">> NENI nastaven zdroj dat. Prosim NASTAVTE zdroj. <<"
    @ 0,0 say RAD_0 colo R*/W
  endi
  *-----*
  @ 0,0 say spac(80)
  @ 0,60 say " "+dtoc(date())+" "
  *-----*
  @ 1,0 to 1,79
  @ 2,0 say space(80)
  @ 3,0 to 3,79
  for A=4 to 20
    @ A,0 say ""+;
    ""
  endf
  @ 21,0 to 21,79
  @ 22,0 say space(80)
  RAD_23 = spac(41)+"KURZOR vyber, ENTER odeslani, ESC zpet "
  @ 23,0 say RAD_23
  @ 24,0 to 24,79
  *-----*
  clea gets
  *-----*
  SMHES=.T.
  do whil SMHES
    * - smycka SMHES umozni pri chybnem zadani hesla opakovat cyklus
    *-----*
    if HESLO()==.T.
      *   zobrazeni zdroje az po zadani hesla
      *-----*
      if !left(RAD_0,2)==">>"
        @ 0,0 say RAD_0
      endi
      if !file(PR_ZDR+"DATA\"+PR_JMZ+".CDX")
        =W_MSG_TALK(" NEEXISTUJE soubor >> *.CDX <<. Nutno REINDEXOVAT. ")
      endi
      *-----*
      *   kontrola spravne struktury tabulky databaze
      *-----*
      do INFOK with 1
      *-----*
      SMYCKA=.t.
      do while SMYCKA
        acti menu HLAVNI
        if last()==27
          @ 2,1  say " Data "
          @ 2,7  say " Nastroje "
          @ 2,17 say " Program "
          @ 2,69 say " Ukonceni "
          do UKONCENI
        endi
      endd
    endi
    *-----*
    * - last() zde osetri ukonceni programu INFO pri neznalosti hesla
    *   a naslednem stisku ESC
    * - global.promen. ME_KON osetri nesmyslne zobrazeni pri ukonceni INFO
    *-----*
    if last()==27 or ME_KON==1
      exit
    endi
  endd
  *-----*
retu
*------------------------------------------------------------*
*------------------------------------------------------------*
*   podprogramy, procedury, funkce
*------------------------------------------------------------*
*------------------------------------------------------------*
***********
*   HL_AKCE - spousteni jednotlivych akci
***********
proc HL_AKCE
para PPAD, PBAR
  =WMSGWAIT(.t.)
  do case
  case PPAD=="DATA"
    do case
    case PBAR==1
      *   zobrazeni, opravy, vkladani, ruseni
      *-----*
      hide menu all
      hide popu all
      do INFOD
      show menu all
    case PBAR==2
      *   jine zobrazeni a opravy
      *-----*
      hide menu all
      hide popu all
      do INFOD1
      show menu all
    case PBAR==3
      *   nepouzito - podtrzeni
    case PBAR==4
      *   reindexace
      *-----*
      do INFOR
    case PBAR==5
      *   kontrola a nekonzistence
      *-----*
      do INFOK with 2
    endc
*------------------------------------------------------------*
  case PPAD=="NASTROJE"
    do case
    case PBAR==1
      *   tiskovy manazer
      *-----*
      do INFOT
    case PBAR==2
      *   nastaveni programu
      *-----*
      do INFON
    case PBAR==3
      *   zaloha
      *-----*
      do INFOZ
    case PBAR==4
      *   archivace
      *-----*
      do INFOA
    case PBAR==5
      *   nepouzito - podtrzeni
    case PBAR==6
      *   generace struktury
      *-----*
      do INFOK with 3
    case PBAR==7
      *   specialni akce - libovolny prikaz MS-DOS
      *-----*
      do INFOS
    endc
  endc
  =WMSGWAIT(.f.)
retu
*----------------------------------------------------------*
*----------------------------------------------------------*
**************
*   WMSGWAIT() - okno zpravy cekani
**************
func WMSGWAIT
para F_MSGSTAV
  if F_MSGSTAV==.t.
    defi wind WMSGWAIT from 19,59 to 21,74 shad colo sche 18
    acti wind WMSGWAIT
    =SYS(2008,"I",2)
    @ 0,0 say "  Cekejte...  " colo *W+/R
    =SYS(2008,"I")
  else
    rele wind WMSGWAIT
  endi
retu
*----------------------------------------------------------*
**************
*   W_MSG_TALK - uzivatelske okno zprav s pouzitim wait
**************
func W_MSG_TALK
para W_MSG_PAR
  *   obsahuje 1 parametr - konkretni zpravu
  *   ta musi byt CHAR a maximalne 70 znaku dlouha, jinak je uriznuta
  *-----*
  =sys(2002)
  if !empt(allt(W_MSG_PAR))
    if isal(allt(W_MSG_PAR))
      if len(allt(W_MSG_PAR))>70
        W_MSG_PAR=left(allt(W_MSG_PAR),67)+"..."
      endi
      defi wind W_TALK from 19,74-(len(allt(W_MSG_PAR))+2) to 21,75 ;
      colo sche 18 shad
      acti wind W_TALK
      @ 0,0 say " "+allt(W_MSG_PAR)+" " colo W+/R
      wait "" wind time 99
      W_MSG_PAR=""
      rele wind W_TALK
    else
      wait "Zprava neni typu CHARACTER" wind time 99
    endi
  else
    wait "Zprava je prazdna" wind time 99
  endi
  =sys(2002,1)
retu
*----------------------------------------------------------*
**************
*   W_MSG_1TAL - uzivatelske okno zprav s pouzitim wait - 2 radky
**************
func W_MSG_1TAL
para W_MSG_1PAR, W_MSG_2PAR
  *   obsahuje 2 parametry - konkretni 2 radky zpravy
  *   ta musi byt CHAR a maximalne 70 znaku dlouha, jinak je uriznuta
  *-----*
  =sys(2002)
  if !empt(allt(W_MSG_1PAR)) or !empt(allt(W_MSG_2PAR))
    if isal(allt(W_MSG_1PAR)) or isal(allt(W_MSG_2PAR))
      if len(allt(W_MSG_1PAR))>70 or len(allt(W_MSG_2PAR))>70
        W_MSG_1PAR=left(allt(W_MSG_1PAR),67)+"..."
        W_MSG_2PAR=left(allt(W_MSG_2PAR),67)+"..."
      endi
      defi wind W_TALK from 18,74-(len(allt(W_MSG_1PAR))+2) to 21,75 ;
      colo sche 18 shad
      acti wind W_TALK
      @ 0,0 say " "+allt(W_MSG_1PAR)+" " colo W+/R
      @ 1,0 say " "+allt(W_MSG_2PAR)+" " colo W+/R
      wait "" wind time 99
      W_MSG_1PAR=""
      W_MSG_2PAR=""
      rele wind W_TALK
    else
      wait "Zprava (2rad) neni typu CHARACTER" wind time 99
    endi
  else
    wait "Zprava (2rad) je prazdna" wind time 99
  endi
  =sys(2002,1)
retu
*----------------------------------------------------------*
*********
*   HESLO - osetreni pusteni heslem
*********
func HESLO
  if empt(PR_HES)
    @ 23,0 say spac(70)+" ESC zpet "
    =W_MSG_TALK;
    ("Program lze pouzit jen kdyz je nadefinovane heslo.")
    @ 23,0 say RAD_23
    retu(.F.)
  else
    @ 0,0 say "INFO.EXE (v) 2.0"
    @ 23,0 say spac(54)+" ENTER odeslani, ESC zpet "
    *-----*
    defi wind OSW from 6,38 to 10,68 doub shad ;
    titl " Vstupni heslo " colo sche 17
    acti wind OSW
    VST_HES=spac(10)
    @ 1,2 say "Zadejte heslo: "
    @ 1,17 get VST_HES pict "@!" colo N/N,N/N
    read
    clea read
    clea gets
    *-----*
    if allt(uppe(left(PR_HES,10)))==allt(uppe(VST_HES))
      rele wind OSW
    else
      if !last()==27
        =W_MSG_TALK("Nespravne heslo")
      endi
      rele wind OSW
      @ 23,0 say RAD_23
      retu(.F.)
    endi
  endi
  @ 23,0 say RAD_23
retu(.T.)
*----------------------------------------------------------*
************
*   NAPOVEDA - informace o verzi programu
************
proc NAPOVEDA
  *   shozeni hlasky cekani
  *-----*
  =WMSGWAIT(.f.)
  *-----*
  *   vypina / zapina kurzor
  *-----*
  =SYS(2002)
  acti scre
  @ 23,0 say spac(70)+" ESC zpet "
  *----*
  defi wind NAO_PRG from 9,11 to 18,74 doub titl " O programu " ;
  colo sche 19 shad
  acti wind NAO_PRG
  *-----*
  @ 1,4 say spac(54) colo GR+/G
  @ 2,4 say "   INFO.EXE (v) 2.0 " +spac(5) +"09.09.1999" +spac(4) +;
  "(c)1999/09JH   " colo GR+/G
  @ 3,4 say ;
  "   Program k jednoduche evidenci ruznych informaci,   " colo GR+/G
  @ 4,4 say ;
  "   ukolu a udaju v podobe datovych  *.DBF  souboru.   " colo GR+/G
  @ 5,4 say ;
  "   Bylo vytvoreno ve FOXPRO 2.0 verze z 15.11.1991.   " colo GR+/G
  @ 6,4 say spac(54) colo GR+/G
  *-----*
  wait "" time 99
  rele wind NAO_PRG
  acti scre
  @ 23,0 say RAD_23
  =SYS(2002,1)
retu
*----------------------------------------------------------*
************
*   UKONCENI - ukonceni programu, navrat do operacniho systemu
************
proc UKONCENI
  *   promenna ME_KON je nadefinovana jiz ve vyssi urovni v hlavni
  *   procedure HLAVNI v cyklu SMHES pro osetreni nezobrazeni hesla
  *   pri zaverecnem ukonceni celeho programu INFO
  *-----*
  defi wind KONEC from 11,14 to 13,65 doub titl " Ukonceni " ;
  colo sche 17 shad
  acti wind KONEC
  SM=.t.
  do while SM
	@ 0,1 say " Prejete si ukoncit tento program ?  "
	@ 0,38 prom " \<ANO " mess ;
	" Ukonceni programu. " colo ,N/G,,,,,W+/G
	@ 0,44 prom " \<NE " mess ;
	" Navrat do menu - pokracovani programu. " colo ,N/G,,,,,W+/G
	ME_KON=2
	menu to ME_KON
	clea prom
	if ME_KON==0.or.ME_KON==2 
	  SM=.f.
	  rele wind KONEC
	endif
	if ME_KON==1
	  SM=.f.
	  SMYCKA=.f.
	  rele wind KONEC
      deac menu all
	endif
  endd
retu
*----------------------------------------------------------*
*********
*   CHYBA - osetreni chyb
*********
proc CHYBA
para P_ERR,P_MES,P_MES1,P_LINE,P_PROG
  *   shodi hlasku cekani
  *-----*
  =WMSGWAIT(.f.)
  *-----*
  *   osetreni konkretniho problemu - tiskovy manazer - pristup k souboru
  *-----*
  if P_ERR==1705 and allt(left(P_PROG,3))=="TM_"
    =W_MSG_TALK("Pristup k souboru neni povolen.")
    retu
  endi
  *-----*   OSETRENI CHYB FILTRU V HLEDANI V SEZNAMU PROHLIZENI - F7
  * - tato cast vypisu chyb se pouziva pri ruttinnim provozu,
  * - P_FILT je pouzit pro osetreni pouziti obecneho filtru hledani
  *   v programu INFODH.PRG - F7 hledej
  *-----*
  =W_MSG_TALK(" CHYBA " +allt(str(P_ERR)) +" - "+left(P_MES,50) +" ")
  P_FILT=""
*** retu
*-----*
*   prikaz RETU zde se aktivuje po rutinni provoz programu INFO,
*   pro ladeni pokracuje podrobnejsi vypis chyby
*-----*
*   chyby - pokracovani - pouzito pouze pro fazi ladeni
*-----*
  defi wind WERR from 6,3 to 16,76 titl "  C H Y B A  " doub ;
  foot "[ Po zapsani chyby ukoncete stiskem ESC ]" colo W+/R,,W+/R,W+/R
  acti wind WERR
  *-----*
  ? "  " +repl("=",3) +" START, " +DTOC(DATE()) +", " +TIME()+;
  ", INFO.EXE (v) 2.0 " +repl("=",18)
  *-----*
  ? space(3)+"CHYBA  cislo   [ "+allt(str(P_ERR))+ ;
  " ]  O teto chybe informujte programatora."
  ? space(3)+"Popis chyby    [ " +left(P_MES,48)+ ;
  space(48-len(left(P_MES,48)))+ " ]"
  ? space(3)+"Chybny program [ " +righ(P_PROG,48)+ ;
  space(48-len(righ(P_PROG,48)))+" ]"
  ? space(3)+"Chybna radka   [ " +left(P_MES1,48)+ ;
  space(48-len(left(P_MES1,48)))+" ]"
  ? space(3)+"Cislo chybne radky v programu   [ " +allt(str(P_LINE))+" ]"
  *-----*
  ? "  "+repl("=",3)+" KONEC, "+DTOC(DATE())+", "+TIME()+" "+repl("=",36)
  *-----*
  wait "" wind
  rele wind WERR
retu
*----------------------------------------------------------*
***********
*   BARVA() - nastaveni barev
***********
func BARVA
para ODPOVED
  if !empt(ODPOVED)
    if ODPOVED=="KO"
      *-----*
      *   nastaveni puvodnich barev
      rest from INFOB
      set colo of sche 1 to (PR_BV1)
      set colo of sche 2 to (PR_BV2)
      set colo of sche 3 to (PR_BV3)
      set colo of sche 4 to (PR_BV4)
      set colo of sche 5 to (PR_BV5)
      set colo of sche 6 to (PR_BV6)
      set colo of sche 7 to (PR_BV7)
      set colo of sche 8 to (PR_BV8)
      set colo of sche 9 to (PR_BV9)
      set colo of sche 10 to (PR_BV10)
      set colo of sche 11 to (PR_BV11)
      set colo of sche 12 to (PR_BV12)
      set colo of sche 13 to (PR_BV13)
      set colo of sche 14 to (PR_BV14)
      set colo of sche 15 to (PR_BV15)
      set colo of sche 16 to (PR_BV16)
      set colo of sche 17 to (PR_BV17)
      set colo of sche 18 to (PR_BV18)
      set colo of sche 19 to (PR_BV19)
      set colo of sche 20 to (PR_BV20)
      set colo of sche 21 to (PR_BV21)
      set colo of sche 22 to (PR_BV22)
      set colo of sche 23 to (PR_BV23)
      set colo of sche 24 to (PR_BV24)
      rest scre from PR_BVZAKL
      retu
    endi
  endi
  *-----*
  *   uchovani puvodnich barev v aktualnim adresari
  PR_BV1=sche(1)
  PR_BV2=sche(2)
  PR_BV3=sche(3)
  PR_BV4=sche(4)
  PR_BV5=sche(5)
  PR_BV6=sche(6)
  PR_BV7=sche(7)
  PR_BV8=sche(8)
  PR_BV9=sche(9)
  PR_BV10=sche(10)
  PR_BV11=sche(11)
  PR_BV12=sche(12)
  PR_BV13=sche(13)
  PR_BV14=sche(14)
  PR_BV15=sche(15)
  PR_BV16=sche(16)
  PR_BV17=sche(17)
  PR_BV18=sche(18)
  PR_BV19=sche(19)
  PR_BV20=sche(20)
  PR_BV21=sche(21)
  PR_BV22=sche(22)
  PR_BV23=sche(23)
  PR_BV24=sche(24)
  save scre to PR_BVZAKL
  save to INFOB all like PR_BV*
  *--------------------*
  *   nastaveni barev
  *--------------------*
  *-----* C1 barva1
  if empt(PR_COL) or allt(uppe(PR_COL))=="C1"
    set colo of sche  1 to ;
    W+/W, N/W, W+/W, W+/W+, W+/W, W+/N, N/W, N+/N, W/N, N+/N
    set colo of sche  2 to ;
    N+/W, N/W, W+/W, W/N, W+/W, W+/N, W+/W, N+/N, W/N, N+/N
    set colo of sche  3 to ;
    N+/W, N/W, W+/W, W/N, W+/W, W+/N, W+/W, N+/N, W/N, N+/N
    set colo of sche  4 to ;
    N+/W, N/W, W+/W, W+/W, W+/W, W/N, W+/W, N+/N, N+/W, W+/W
    set colo of sche  5 to ;
    W+/W, W+/G, W+/N, W+/N, W+/N, G+/N, W+/N, W+/W, N/W, N+/N
    set colo of sche  6 ;
    to W/N, N/W, W+/W, W+/W, W+/W, W+/G, W+/N, N+/N, W/N, N+/N
    set colo of sche  7 ;
    to W+/G, N/W, W+/W, W+/W, W+/W, G+/N, GR+/G, N+/N, W+/G, N+/N
    set colo of sche  8 ;
    to W+/G, W/N, W+/W, W+/W, W+/W, G+/N, GR+/G, N+/N, W/G, N+/G
    set colo of sche  9 ;
    to W/G, W+/G, N/G, W+/N, W+/N, W+/W, W+/N, N+/N, W/N, N+/N
    set colo of sche 10 ;
    to G/N, G+/N, W+/N, W+/N, W+/N, N/G, N/G, N+/N, W/N, N+/N
    *-----*
    *   zelena - pro ukonceni a nektera informacni okna,
    set colo of sche 17 to ;
    W+/G, W+/G, W+/G, W+/G, W+/G, W+/G, W+/G, W+/G, W+/G, W+/G
    set colo of sche 18 to ;
    W+/R, W+/N, W+/R, W+/R, W+/R, W+/R, W+/R, N+/N, n/w, N+/N
    set colo of sche 19 to ;
    W+/W, w+/n, W+/W, W+/W, W+/W, W+/N, W+/W, N+/N, n/w, N+/N
    set colo of sche 20 to ;
    W+/W, N/W, W+/W, W+/W, W+/W, W+/N, W+/W, N+/N, W/N, N+/N
    set colo of sche 21 to ;
    G+/N, W+/G, W+/W, W+/W, W+/W, W+/W, N/G, N+/N, W+/W, N/W
    set colo of sche 22 to ;
    N+/W, N/W, W+/W, W+/W, W+/W, W+/N, W+/W, N+/N, W+/W, N/W
    set colo of sche 23 to ;
    GR+/N, W+/GR+, W+/W, W+/W, W+/W, GR+/W+, N/W, N+/N, W+/W, N/W
  endi
  *-----* M mono
  if allt(uppe(PR_COL))=="M"
    set colo to W/N
    set colo of sche  1 to ;
    W/N,N/W,N/W,N/W,n/W,N/W,N/W,N+/N,W/N,N+/N,-
    set colo of sche  2 to ;
    N+/N,W/N,W/N,W/N,W/N,N/W,W+/N,N+/N,W/N,N+/N,-
    set colo of sche  3 to ;
    N+/W,N/W,W/N,,,W/N,,,,,-
    set colo of sche  4 to ;
    N+/W,N/W,N/W,,,W/N,,,,,-
    set colo of sche  5 ;
    to W+/N,W+/GR+,W+/N,W+/N,W+/N,W+/W,W+/N,N+/N,W/N,N+/N,-
    set colo of sche  8 to ;
    N+/N,W/N,W/N,W/N,W/N,N/W,W+/N,N+/N,W/N,N+/N,-
    *-----*
    set colo of sche 19 to ;
    W/N,W/N,W/N,W/N,W/N,N/W,N/W,N+/N,W/N,N+/N,-
    set colo of sche 21 to ;
    G/W,N/W,N/W,W+/W,W+/W,W+/N,W+/W,N+/N,W+/W,W/N,-
    set colo of sche 22 to ;
    N+/W,N/W,W+/W,W+/W,W+/W,W+/N,W+/W,N+/N,W+/W,N/W,-
    set colo of sche 23 to ;
    G+/N,G+/N+,W+/W,W+/W,W+/W,W+/G,W+/W,N+/N,W+/W,N+/W,-
    set colo of sche 24 to ;
    N/W,G+/N,W+/W,W+/W,W+/W,W+/N,N/W,N+/N,W+/W,N+/W,-
  endi
retu(ODPOVED)
*----------------------------------------------------------*
**********
*   SETY() - nastavuje (.t.) / vypina set prikazy (.f.)
**********
func SETY
para VYPINAC
  if VYPINAC=.t.
    *-----*
    *   zurnal v pracovnim adresari, hlidani velikosti 20 KB
    *   po prekroceni 20KB provede jednu zalohu, vse se opakuje
    *-----*
    if file("INFO.ZUR")
      =adir(POLE,"INFO.ZUR")
      if POLE(1,2)>20000
        set safe off
        copy file INFO.ZUR to INFO.ZZU
        dele file INFO.ZUR
        set safe on
      endi
    endi
    set alte to INFO.ZUR addi
    set alte on
    *-----*
    *   neuvazuje vety oznacene k ruseni
    *-----*
	set bell off
	set cent on
	set cloc on	
	set cloc to 0,72
	set conf on
	set curs on
	set date germ
	set dele on
	set devi to scre
    set esca off
	set exac on
	set excl off
	set help off
	set hour to 24
	set inte on
	set mack to
	set memo to 70
	set mess to 22
	set mous off
	set near off
	set noti on
	set reso off
	set safe off
	set shad on
	set stat off
    set sysm off
	set talk on
	set talk wind
	*-----*
	set func F1 to
	set func F2 to
	set func F3 to
	set func F4 to
	set func F5 to
	set func F6 to
	set func F7 to
	set func F8 to
	set func F9 to
  else
    *-----*
    *   zurnal
    set alte off
    set alte to
    *-----*
	set bell on
	set cent off
	set cloc off
	set conf on
	set curs on
	set date brit
	set dele off
	set devi to scre
	set esca on
	set exac off
	set excl on
	set help on
	set hour to
	set inte on
	set mack to SHIFT+F10
	set memo to 50
	set mess to
	set mous on
	set near off
	set noti on
	set reso on
	set safe on
	set shad on
	set stat off
	set sysm on
	set talk nowi
	set talk on
	*-----*
	set func F1 to "HELP;"
	set func F2 to "SET;"
	set func F3 to "LIST;"
	set func F4 to "DIR;"
	set func F5 to "DISP STRU;"
	set func F6 to "DISP STAT;"
	set func F7 to "DISP MEMO;"
	set func F8 to "DISP;"
	set func F9 to "APPE;"
  endif
retu
*
*: EOF: INFO.PRG
