***   INFOD.PRG
***   D_ata - zobrazeni, opravy, ruseni, vkladani
***   podprogram (v) 2.0, JH 9.9.1999,
*----------------------------------------------------------*
  *   shodi hlasku cekani
  *-----*
  =WMSGWAIT(.f.)
  *-----*
  * - h_text - definovano v teto urovni pro potrebu zviditelneni
  *   a moznosti otestovani odkud je inicializovano volani f3-zobraz
  * - h_text se testuje v infodp.prg, dale se pouziva v infodh.prg
  * - pp_prg - pomocna pro test o jaky program jde - infod / infod1
  *-----*
  H_TEXT=""
  PP_PRG="INFOD"
  *-----*
  @ 0,0 say spac(80)
  @ 0,0 say RAD_0
  @ 0,60 say " "+dtoc(date())+" "
  *-----*
  RAD_1_1="Vet "
  RAD_1_2=" Tridi "
  RAD_1_3=" Filtr  "
  RAD_24 = spac(41)+"KURZOR vyber, ENTER odeslani, ESC zpet "
  *-----*
  @ 1,0 say RAD_1_1
  @ 1,10 say RAD_1_2
  @ 1,27 say RAD_1_3
  *-----*
  =SYS(2008,"I",2)
  *-----*
  defi wind WD1 from 18,0 to 23,79 pane
  *-----*
  *   exclusivne otevrit pro moznost pack pri ruseni v 1.oblasti
  sele 1
  set excl on
  use (PR_ZDR+"DATA\"+PR_JMZ) alia J_MZ
  set excl off
  *-----*
  P_VET=recc()
  P_TRID="POPIS"
  P_FILT=""
  if file(PR_ZDR+"DATA\"+PR_JMZ+".CDX")
    set orde to tag (P_TRID) of (PR_ZDR+"DATA\"+PR_JMZ)
  else
    =W_MSG_TALK(" NEEXISTUJE soubor >> *.CDX <<. Nutno REINDEXOVAT. ")
    P_TRID="nelze"
  endi
  *-----*
  @ 1,4  say allt(str(P_VET)) colo N/W
  @ 1,17 say allt(P_TRID) colo N/W
  @ 1,34 say allt(P_FILT) colo N/W
  @ 24,0 say RAD_24
  @ 24,0 say " F10 nabidka akci"
  *-----*
  defi wind WD0 from 2,0 to 18,79 pane colo sche 21
  acti wind WD0
  go top
  *-----*
  =HOTKEY(.t.)
  do whil !last()==27
    if P_VET>0
      brow node noap nomo nome when ZMENA_VETY() in wind WD0
    else
      do D_NEJSOU
      *-----*
      *   je-li stisknuto v-118, V-86
      *-----*
      if last()==118 or last()==86
        appe blan
        keyb "{ENTER}"
      endi
      exit
    endi
  endd
  =HOTKEY(.f.)
  *-----*
  sele 1
  use
  *-----*
  rele wind WD0,WD1
  *-----*
  =SYS(2008,"I")
  *-----*
  @ 1,0 to 1,79
  @ 24,0 to 24,79
retu
*----------------------------------------------------------*
*----------------------------------------------------------*
*   podprogramy, procedury, fce
*----------------------------------------------------------*
*----------------------------------------------------------*
***********
*   D_OBCER - obcerstveni zakladniho zobrazeni
***********
func D_OBCER
  acti scre
  @ 1,0 say RAD_1_1
  @ 1,10 say RAD_1_2
  @ 1,27 say RAD_1_3
  @ 24,0 say RAD_24
  @ 1,4  say allt(str(P_VET)) colo N/W
  @ 1,17 say allt(P_TRID) colo N/W
  @ 1,34 say allt(P_FILT) colo N/W
  @ 24,0 say " F10 nabidka akci"
  =ZMENA_VETY()
retu
*----------------------------------------------------------*
****************
*   ZMENA_VETY()
****************
func ZMENA_VETY
  * - fraze when u brow aktivuje tuto udf() na aktualni vete
  * - zobrazi dolni okno s obcerstvenim
  *--------------------*
  * - ukol je vazan jen na R,P,S
  * - kod  K=R  - ukol ve fazi ROZPRACOVAN,
  *        K=P  - ukol ve fazi POZASTAVEN,
  *        K=S  - ukol ve fazi SPLNEN,
  *-----*
  *        K=N  - NEPREHLEDNI, nesmi byt u ukolu
  *-----*
  * - stav muze mit kazda veta,
  * - stav S=A archiv  - libovolna veta urcena k zaarchivovani,
  *        S=X oznacen - oznaceni libovolne vety pro hromadne akce,
  *        S=N novy    - uplne nova dodana informace
  *        S=I import  - prave importovane informace
  *        S=E export  - informace urcene pro export
  *-----*
  *   promenne pro chybove hlasky osetrenych get objektu
  *--------------------*
  acti wind WD1
  *-----*
  @ 0,1  say ;
  "Heslo         Termin .. hodin :  K=  S= "
  @ 0,7  say allt(HESLO) colo N/W
  @ 0,27 say iif(left(TERMIN,2)=="  ","",allt(TERMIN)) colo N/W
  @ 0,44 say iif(left(TER_HOD,2)=="  ","",allt(TER_HOD)) colo N/W
  @ 0,53 say K colo N/W
  @ 0,58 say S colo N/W
  @ 0,62 say "Zdroj / kontakt"
  @ 1,1  say "Typy          Splnen .." +spac(23) +""
  @ 1,7  say allt(TYPY) colo N/W
  @ 1,27 say iif(left(TER_SPL,2)=="  ","",allt(TER_SPL)) colo N/W
  @ 1,62 say ""
  @ 1,62 say iif(empt(ZDROJ),"",allt(ZDROJ)) colo N/W
  @ 2,1  say ;
  "Komu   Ĵ"
  @ 2,7  say allt(PROKOHO) colo N/W
  @ 2,62 say ""
  @ 2,62 say iif(empt(KONTAKT),"",allt(KONTAKT)) colo N/W
  @ 3,1  say "Zapis .."
  @ 3,7  say iif(left(DAT_ZAP,2)=="  ","",allt(DAT_ZAP)) colo N/W
  @ 3,20 say "Uprava .."
  @ 3,27 say iif(left(DAT_UPR,2)=="  ","",allt(DAT_UPR)) colo N/W
  @ 3,40 say "Zapsal  "
  @ 3,47 say allt(ZAPSAL) colo N/W
  *-----*
  PP_TTEE=tran(len(TEXT1)/1000,"####.##")+" KB"
  @ 3,62 say "TEXT1"
  @ 3,67 say iif(empt(allt(TEXT1))," n e n i  ",PP_TTEE) colo N/W
  *-----*
  clea gets
  *-----*
  if allt(K)=="R" and allt(HESLO)=="UKOL"
    @ 1,38 say "  ROZPRACOVANO  " colo GR+/R
  endi
  if allt(K)=="P" and allt(HESLO)=="UKOL"
    @ 1,38 say " POZASTAV. UKOL " colo W+/R
  endi
  if allt(K)=="S" and allt(HESLO)=="UKOL"
    @ 1,38 say " UKOL JE SPLNEN " colo W+/G
  endi
  if allt(K)=="N" and allt(HESLO)<>"UKOL"
    @ 1,38 say " NEPREHLEDNOUT  " colo GR+/BG
  endi
  if allt(K)=="_"
    @ 1,38 say spac(16)
  endi
  *-----*
  if allt(S)=="A"
    @ 1,56 say "ARC" colo W+/B
  endi
  if allt(S)=="X"
    @ 1,56 say ">X<" colo W+/N
  endi
  if allt(S)=="N"
    @ 1,56 say "NOV" colo GR+/BG
  endi
  if allt(S)=="I"
    @ 1,56 say ">I<" colo W+/R
  endi
  if allt(S)=="E"
    @ 1,56 say ">E<" colo W+/R
  endi
  if allt(S)=="_"
    @ 1,56 say "   "
  endi
  *-----*
  *   navrat do okna brow
  acti wind WD0
retu
*----------------------------------------------------------*
************
*   D_NEJSOU - neexistuji zadna data
************
proc D_NEJSOU
  acti wind WD1
  *-----*
  @ 0,1  say ;
  "Heslo         Termin .. hodin :  K=  S= "
  @ 0,62 say "Zdroj / kontakt"
  @ 1,1  say "Typy          Splnen .." +spac(23) +""
  @ 1,62 say ""
  @ 2,1  say ;
  "Komu   Ĵ"
  @ 2,62 say ""
  @ 3,1  say "Zapis .."
  @ 3,20 say "Uprava .."
  @ 3,40 say "Zapsal  "
  @ 3,62 say "TEXT1 n e n i "
  *-----*
  =W_MSG_1TAL;
  ("Nyni nastavena databaze > " ;
  +repl(" ",8-len(allt(PR_JMZ))) +allt(PR_JMZ) +".DBF < je PRAZDNA.",;
   "Stisk ESC ukonci prohlizeni. Stisk  V  vlozi 1.vetu.")
  *-----*
  *   navrat do okna brow
  acti wind WD0
retu
*----------------------------------------------------------*
************
*   HOTKEY() - nastavovani funkcnich klaves
************
func HOTKEY
para F_STAV
  if F_STAV==.t.
    *-----*
    *   vyblokovani cteni mema
    on key labe CTRL+HOME keyb "{RIGHTARROW}"
    on key labe CTRL+PGUP keyb "{RIGHTARROW}"
    on key labe CTRL+PGDN keyb "{RIGHTARROW}"
    *-----*
    on key labe F3 do INFODP
    on key labe F4 do INFODO
    on key labe F5 do INFODK
    on key labe F7 do INFODH
    on key labe F8 do INFODR
    on key labe F9 do INFODV
    *-----*
    on key labe CTRL+I do INFODIE
    on key labe CTRL+N do INFOD_N
    on key labe CTRL+V do INFOD_V
    on key labe CTRL+T do INFODT
    *-----*
    on key labe F10 do MENU10
  else
    on key
  endi
retu
*----------------------------------------------------------*
**********
*   MENU10 - menu akci
**********
proc MENU10
  =HOTKEY(.f.)
  *-----*
  acti scre
  @ 24,0 say space(35)
  *-----*
  defi popu MENU10 from 3,1 in screen shad colo sche 22
  defi bar 1  of MENU10 prom " \<Prohlizeni textu     F3 "
  defi bar 2  of MENU10 prom " \<Hledani v seznamu    F7 "
  defi bar 3  of MENU10 prom "\-"
  defi bar 4  of MENU10 prom " \<Oprava informaci     F4 "
  defi bar 5  of MENU10 prom " \<Kopie informaci      F5 "
  defi bar 6  of MENU10 prom " \<Ruseni informaci     F8 "
  defi bar 7  of MENU10 prom " \<Vlozeni informaci    F9 "
  defi bar 8  of MENU10 prom "\-"
  defi bar 9  of MENU10 prom " \<Import/export    CTRL+I "
  defi bar 10 of MENU10 prom " \<Nacteni do TEXT1 CTRL+N "
  defi bar 11 of MENU10 prom " V\<ystup z TEXT1   CTRL+V "
  defi bar 12 of MENU10 prom "\-"
  defi bar 13 of MENU10 prom " \<Tisk informaci   CTRL+T "
  on sele popu MENU10 do MENU10_BEH with bar()
  *-----*
  acti popu MENU10
  rele popu MENU10
  *-----*
  acti scre
  @ 24,0 say " F10 nabidka akci"
  *-----*
  acti wind WD0
  =HOTKEY(.t.)
retu
*----------------------------------------------------------*
**************
*   MENU10_BEH - menu akci
**************
proc MENU10_BEH
para PBAR 
  hide popu MENU10
  *-----*
  do case
  case PBAR==1
    *   prohlizeni
    do INFODP
  case PBAR==2
    *   hledani v seznamu
    do INFODH
  case PBAR==3
    *   nepouzito
  case PBAR==4
    *   oprava
    do INFODO
  case PBAR==5
    *   kopirovani
    do INFODK
  case PBAR==6
    *   ruseni
    do INFODR
  case PBAR==7
    *   vlozeni
    do INFODV
  case PBAR==8
    *   nepouzito
  case PBAR==9
    *   import / export
    do INFODIE
  case PBAR==10
    *   nacteni do text1
    do INFOD_N
  case PBAR==11
    *   vystup z text1
    do INFOD_V
  case PBAR==12
    *   nepouzito
  case PBAR==13
    *   tisk seznamu
    do INFODT
  endc
  *-----*
  deac popu MENU10
retu
*
*: EOF: INFOD.PRG
