***   INFOK.PRG
***   K_ontrola struktury, konzistence a spravneho zapsani dat,
***   podprogram (v) 2.0, JH 9.9.1999,
*----------------------------------------------------------*
*   k_typ - typ kontroly,
*      1-spustenim programu-struktura a z menu nastroje-natsaveni dat
*      2-z menu-konzistence
*      3-z menu nastroje-generace struktury
*----------------------------------------------------------*
para K_TYP
  *   shodi hlasku cekani
  *-----*
  =WMSGWAIT(.f.)
  *-----*
  if !empt(K_TYP) and K_TYP==2
    defi wind WK from 7,16 to 11,41 shad
    acti wind WK
    *-----*
    @ 0,0 prom " Provede akci \<kontrola  " mess ;
    " Provede se vlastni kontrola konzistence prave nastavene databaze. "
    @ 1,0 prom " \<Zobrazi chybovy soubor " mess ;
    " Zobrazi vznikly soubor s popisem nalezenych chyb. "
    @ 2,0 prom " Z\<rusi chybovy soubor   " mess ;
    " Zrusi chybovy soubor, existuje-li. "
    K_VOL=1
    menu to K_VOL
    *-----*
    *   vypina / zapina kurzor
    *-----*
    =SYS(2002)
    if K_VOL=1
      do KONT_AKCE
    endi
    if K_VOL=2
      do KONT_ZOBR
    endi
    if K_VOL=3
      do KONT_RUSI
    endi
    *-----*
    *   zapina kurzor
    *-----*
    =SYS(2002,1)
    *-----*
    rele wind WK
  else
    if !empt(K_TYP) and K_TYP==1
      do KONT_STRU
    else
      if !empt(K_TYP) and K_TYP==3
        do KONT_GEN
      else
        =W_MSG_TALK(" Chybi zadat parametr 1/2/3 pri pousteni INFOK.PRG ")
      endi
    endi
  endi
  *-----*
  *   nespusteno z prohlizeni
  *-----*
  if !wexi("WD0") and !wexi("WD1")
    @ 23,0 say RAD_23
  endi
retu
*----------------------------------------------------------*
*----------------------------------------------------------*
*   podprogramy, procedury, fce
*----------------------------------------------------------*
*----------------------------------------------------------*
*************
*   KONT_STRU - kontrola spravne struktury otevrene databaze
*************
* - kopie struktury prave nastavene tabulky, obl.2-infotmp.tmp,
* - porovna tuto strukturu se vzorovou v obl.3-infocfg.dbf,
* - k_tmp pocet vet nastavene tabulky,
* - k_cfg pocet vet vzorove tabulky,
* - k_zpr  k_zpr=1 - priznak o nevyhovujici strukture,
*-----*
proc KONT_STRU
  K_TMP=0
  K_CFG=0
  K_ZPR=0
  *-----*
  * - pro pripad pusteni z prohlizeni kdy je v 1.oblasti aktivni
  *   jiz hlavni tabulka se zde vse odehrava v oblastech 2 a 3
  *-----*
  sele 2
  use (PR_ZDR+"DATA\"+PR_JMZ)
  copy stru exte to (PR_ZDR+"INFOTMP.TMP")
  use
  use (PR_ZDR+"INFOTMP.TMP") alia TMP
  K_TMP=recc()
  go top
  sele 3
  use (PR_ZDR+"INFOCFG") alia CFG
  coun for C_K1=="-----" to K_CFG
  go top
  *-----*
  * - pro stejny pocet poli nebo mensi vzor kontroluje presne
  *   nazvy, typy, delky porovnavanzch poli
  * - prochazi vzor radku po radce a hleda presne shodne polozky
  *   v prave nastavene tabulce, pro chybu nastavi k_zpr=1 a konci
  *-----*
  if K_CFG<=K_TMP
    scan for C_K1=="-----"
      sele 2
        go top
        loca for ( allt(CFG.FIELD_NAME)==allt(TMP.FIELD_NAME) and ;
        CFG.FIELD_TYPE==TMP.FIELD_TYPE and ;
        CFG.FIELD_LEN==TMP.FIELD_LEN and CFG.FIELD_DEC==TMP.FIELD_DEC )
        if !foun()
          K_ZPR=1
        endi
      sele 3
      if K_ZPR=1
        exit
      endi
    ends
  else
    K_ZPR=1
  endi
  sele 2
  use
  sele 3
  use
  sele 1
  *-----*
  *   keyb shodi hlasku
  *-----*
  dele file (PR_ZDR+"INFOTMP.TMP")
  keyb "{LEFTARROW}"
  =inke()
  *-----*
  if K_ZPR==1
    *-----*
    *   nespusteno z prohlizeni
    *-----*
    if !wexi("WD0") and !wexi("WD1")
      acti scre
      @ 23,0 say space(70)
    endi
    =sys(2002)
    defi wind WKST from 2,2 to 21,75 ;
    titl " " +uppe(allt(PR_PRC+"DATA\"+PR_JMZ)) +".DBF " ;
    doub shad colo sche 17
    acti wind WKST
    *-----*
    @ 0,2 to 17,37 doub
    *-----*
    @ 1,5   say "Pole Jmeno    Typ   Sire   Des" colo GR+/G
    @ 2,5   say "1    HESLO    Znak     4     0" colo W+/G
    @ 3,5   say "2    TYPY     Znak     4     0" colo W+/G
    @ 4,5   say "3    POPIS    Znak    55     0" colo W+/G
    @ 5,5   say "4    TERMIN   Znak    10     0" colo W+/G
    @ 6,5   say "5    TER_HOD  Znak     5     0" colo W+/G
    @ 7,5   say "6    TER_SPL  Znak    10     0" colo W+/G
    @ 8,5   say "7    DAT_ZAP  Znak    10     0" colo W+/G
    @ 9,5   say "8    DAT_UPR  Znak    10     0" colo W+/G
    @ 10,5  say "9    ZDROJ    Znak    15     0" colo W+/G
    @ 11,5  say "10   KONTAKT  Znak    15     0" colo W+/G
    @ 12,5  say "11   ZAPSAL   Znak    12     0" colo W+/G
    @ 13,5  say "12   PROKOHO  Znak    10     0" colo W+/G
    @ 14,5  say "13   S        Znak     1     0" colo W+/G
    @ 15,5  say "14   K        Znak     1     0" colo W+/G
    @ 16,5  say "15   TEXT1    Memo    10     0" colo W+/G
    *-----*
    @ 1,41 say " K O N T R O L A  STRUKTURY " colo W+/G
    @ 3,41 fill to 16,68 colo W+/W
    @ 4,43  say "Prave  nastavena tabulka" colo W+/W
    @ 5,43  say "nema spravnou  strukturu" colo W+/W
    @ 6,43  say "pozadovanou programem.  " colo W+/W
    @ 7,43  say "  Kompletni struktura je" colo W+/W
    @ 8,43  say "popsana v levem okne.   " colo W+/W
    @ 9,43  say "  Strukturu lze vytvorit" colo W+/W
    @ 10,43 say "rucne nebo vygenerovat v" colo W+/W
    @ 11,43 say "menu  NASTROJE/STRUKTURA" colo W+/W
    @ 12,43 say "jako soub. INFOVZOR.DBF." colo W+/W
    @ 14,43 say "     Je NUTNE radne     " colo GR+/W
    @ 15,43 say "UPRAVIT tabulku ZDROJE !" colo GR+/W
    *-----*
    wait "" wind
    rele wind WKST
    =sys(2002,1)
    *-----*
    *   nespusteno z prohlizeni
    *-----*
    if !wexi("WD0") and !wexi("WD1")
      acti scre
      @ 23,0 say RAD_23
    endi
  endi
retu
*----------------------------------------------------------*
************
*   KONT_GEN - generovani spravne struktury do INFOVZOR.DBF
************
proc KONT_GEN
  * - z infocfg.dbf vytvori zdroj struktury infotmp.tmp
  * - z infotmp.tmp vytvori novou tabulku se spravnou strukturou
  *   infovzor.dbf
  * - smaze pomocny infotmp.tmp
  *-----*
  *   vypina / zapina kurzor
  *-----*
  =SYS(2002)
  @ 23,0 say spac(70)
  defi wind WG from 13,12 to 19,74 titl " Struktura-generovani " ;
  shad colo sche 17
  acti wind WG
  @ 0,2 to 4,58
  @ 2,4 say "Cekejte probiha generovani INFOVZOR.DBF..."
  *-----*
  use (PR_ZDR+"INFOCFG") alia CFG
  copy to (PR_ZDR+"INFOTMP.TMP") for C_K1=="-----"
  use
  crea (PR_ZDR+"DATA\INFOVZOR.DBF") from (PR_ZDR+"INFOTMP.TMP")
  clos data
  *-----*
  G_JM=(uppe(PR_ZDR)+"DATA\INFOVZOR.DBF")
  if len(G_JM) > 44
    G_JM = uppe(allt(left(G_JM,3)))+ " ... "+ ;
    uppe(allt(righ(G_JM,35)))
  endi
  @ 1,7  say "Prave byla vygenerovana prazdna vzorova tabulka"
  @ 2,4  say spac(26-int(len(G_JM)/2)) +G_JM colo GR+/G
  @ 3,7  say "nesouci dobrou strukturu pozadovanou programem."
  *-----*
  wait "" wind
  rele wind WG
  =SYS(2002,1)
  @ 23,0 say RAD_23
  dele file (PR_ZDR+"INFOTMP.TMP")
  keyb "{LEFTARROW}"
retu
*----------------------------------------------------------*
*************
*   KONT_AKCE
*************
proc KONT_AKCE
  acti scre
  @ 23,0 say " Cekejte ... "
  *-----*
  * - kontrola v aktualnim adresari, hlidani velikosti 20 KB - zaloha
  * - vypne standardni zurnal
  * - zapne kontrolni zurnal
  *-----*
  set alte off
  set alte to
  *-----*
  if file("INFOK.ZUR")
    =adir(POLE,"INFOK.ZUR")
    if POLE(1,2)>20000
      set safe off
      copy file INFOK.ZUR to INFOK.ZZU
      dele file INFOK.ZUR
      set safe on
    endi
  endi
  set alte to INFOK.ZUR addi
  set alte on
  *-----*
  @ 23,0 say spac(70)
  *-----*
  defi wind WK1 from 11,8 to 17,70 titl " Kontrola konzistence " ;
  doub shad colo sche 17
  acti wind WK1
  *-------------------------*
  ? "--- ZACATEK KONTROLY " +dtoc(date()) +"  " +time() +"  " +repl("-",17)
  ?
  ? "   Otevreni prave nastavene databaze ... "
  ? "   [ " +uppe(PR_ZDR)+"DATA\"+PR_JMZ +".DBF ]"
  ?
  use (PR_ZDR+"DATA\"+PR_JMZ)
  set orde to tag HESLO of (PR_ZDR+"DATA\"+PR_JMZ)
  go top
  *---------------*
  K_CH=0
  do whil !eof()
    if empt(HESLO)
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - chybi polozka HESLO > " +HESLO +" <"
      K_CH=K_CH+1
    endi
    if empt(TYPY)
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - chybi polozka TYPY > " +TYPY +" <"
      K_CH=K_CH+1
    endi
    if empt(POPIS)
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - chybi polozka POPIS > " +allt(POPIS) +" <"
      K_CH=K_CH+1
    endi
    if DAT_ZAP=="  .  .    "
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - chybi polozka DAT_ZAP > " +DAT_ZAP +" <"
      K_CH=K_CH+1
    endi
    if DAT_UPR=="  .  .    "
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - chybi polozka DAT_UPR > " +DAT_UPR +" <"
      K_CH=K_CH+1
    endi
    if empt(ZAPSAL)
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - spatne vyplnena polozka ZAPSAL > " +ZAPSAL +" <"
      K_CH=K_CH+1
    endi
    *-----*
    if ( HESLO=="UKOL" and (K<>"R" and K<>"P" and K<>"S" and K<>"_") ) ;
    or ( HESLO<>"UKOL" and K<>"N" and K<>"_" )
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - spatne vyplnena polozka K > " +K +" <"
      K_CH=K_CH+1
    endi
    if S<>"X" and S<>"A" and S<>"N" and S<>"I" and S<>"E" and S<>"_"
      ? "  CHYBA - " +HESLO +" " +left(POPIS,30) +"...zaps." +DAT_ZAP
      ? "   - spatne vyplnena polozka S > " +S +" <"
      K_CH=K_CH+1
    endi
    *-----*
    *   uprava na velka pismena
    *-----*
    repl HESLO with uppe(HESLO)
    repl TYPY with uppe(TYPY)
    repl K with uppe(K)
    repl S with uppe(S)
    *-----*
    skip
  endd
  *---------------*
  use
  ?
  ? "   Kontrola databaze provedena. Nalezeno " + allt(str(K_CH)) +" chyb."
  ?
  ? "--- KONEC " +dtoc(date()) +"  " +time() +"  " +repl("-",28)
  ?
  *-------------------------*
  wait "" wind
  rele wind WK1
  acti scre
  @ 23,0 say RAD_23
  *-----*
  *   vypne kontrolni soubor
  *-----*
  set alte off
  set alte to
  *-----*
  *   zapne standardni zurnal
  *-----*
  if file("INFO.ZUR")
    =adir(POLE,"INFO.ZUR")
    if POLE(1,2)>20000
      set safe off
      copy file INFO.ZUR to INFO.ZZU
      dele file INFO.ZUR
      set safe on
    endi
  endi
  set alte to INFO.ZUR addi
  set alte on
retu
*----------------------------------------------------------*
*************
*   KONT_ZOBR - zobrazi chybovy soubor
*************
proc KONT_ZOBR
  if file(PR_ZDR+"INFOK.ZUR")
    defi wind WK1 from 2,1 to 20,76 titl ;
    " Prohlizeni chyb konzistence " ;
    foot " " +uppe(PR_ZDR) +"INFOK.ZUR " ;
    doub shad
    defi wind WK2 from 3,2 to 19,75 titl "" syst ;
    colo GR+/G,,,,,W+/N
    acti wind WK1,WK2
    *-----*
    modi file (PR_ZDR+"INFOK.ZUR") noed wind WK2
    *-----*
    rele wind WK2,WK1
  else
    =W_MSG_TALK("Chybovy soubor >INFOK.ZUR< neexistuje. Stisknete ESC...")
  endi
retu
*----------------------------------------------------------*
*************
*   KONT_RUSI - rusi chybovy soubor
*************
proc KONT_RUSI
  if file(PR_ZDR+"INFOK.ZUR")
    defi wind WR from 12,14 to 18,66 titl " R U S E N I " ;
    doub colo sche 18 shad
    acti wind WR
    if len(PR_ZDR)>13
      R_JMS=left(PR_ZDR,3) +".." +righ(PR_ZDR,8)
    else
      R_JMS=PR_ZDR
    endi
    @ 0,2 to 4,48
    @ 1,3  say " Toto >"+space(24)+"< bude RUSENO "
    @ 1,11 say uppe(R_JMS)+"INFOK.ZUR" colo GR+/R
    @ 2,9  say " RUSIT tento soubor ?  ___   __ "
    @ 2,32 prom " \<ANO " colo ,W/R,,,,,W+/R
    @ 2,38 prom " \<NE " colo  ,W/R,,,,,W+/R
    @ 3,3 say spac(45)
    MSR=2
    menu to MSR
    clea prom
    if MSR=1
      @ 3,3 say " Opravdu rusit kontrolni soubor ? " colo GR+/R
      @ 3,37 prom " \<ANO " colo ,W/R,,,,,W+/R
      @ 3,43 prom " \<NE " colo ,W/R,,,,,W+/R
      P_MSR=2
      menu to P_MSR
      clea prom
      if P_MSR=1
        @ 2,3 say spac(45)
        @ 3,3 say spac(45)
        @ 3,8 say " Cekejte, prave se rusi soubor... " colo *W+/N
        *-----*
        dele file (PR_ZDR+"INFOK.ZUR")
        if file(PR_ZDR+"INFOK.ZZU")
          dele file (PR_ZDR+"INFOK.ZZU")
        endi
        *-----*
      endi
    endi
    rele wind WR
  else
    =W_MSG_TALK("Chybovy soubor >INFOK.ZUR< neexistuje. Stisknete ESC...")
  endi
retu
*
*: EOF: INFOK.PRG

