***   INFOR.PRG
***   R_eindexace,
***   podprogram (v) 2.0, JH 9.9.1999,
*----------------------------------------------------------*
  *   shodi hlasku cekani
  *-----*
  =WMSGWAIT(.f.)
  *-----*
  *   vypina / zapina kurzor
  *-----*
  =SYS(2002)
  @ 23,0 say spac(70)
  *-----*
  defi wind WR from 10,8 to 17,70 titl " Reindexace - rekonstrukce " ;
  doub shad colo sche 17
  acti wind WR 
  *-----*
  ? "   Vznik noveho indexu *.CDX , zacatek " +dtoc(date()) +" "+time()
  ? "   Ruseni starych docas.souboru - existuji-li... "
  if file(PR_ZDR+"DATA\INFOIDX.DBF")
    dele file (PR_ZDR+"DATA\INFOIDX.DBF")
  endi
  if file(PR_ZDR+"DATA\INFOIDX.FPT")
    dele file (PR_ZDR+"DATA\INFOIDX.FPT")
  endi
  if file(PR_ZDR+"DATA\INFOIDX.CDX")
    dele file (PR_ZDR+"DATA\INFOIDX.CDX")
  endi
  *-----*
  ? "   Otevreni prave nastavene databaze " ;
  +uppe(allt(PR_JMZ)) +".DBF ... "
  use (PR_ZDR+"DATA\"+PR_JMZ)
  ? "   Kopirovani databaze do docasne kopie..."
  copy to (PR_ZDR+"DATA\INFOIDX")
  use
  ? "   Exklusivni otevreni docasne databaze..."
  *-----*
  *   exclusivne otevrit pro potrebu pack
  set excl on
  use (PR_ZDR+"DATA\INFOIDX")
  ? "   Setreseni dat pomoci PACK..."
  pack
  set excl off
  *-----*
  ? "   Vytvareni zcela noveho indexu docasne databaze..."
  ? "   - Index polozky HESLO ..."
  inde on HESLO    tag HESLO    of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky TYPY ..."
  inde on TYPY     tag TYPY     of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky POPIS ..."
  inde on POPIS    tag POPIS    of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky ZAPSAL ..."
  inde on ZAPSAL   tag ZAPSAL   of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky PROKOHO ..."
  inde on PROKOHO  tag PROKOHO  of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky TERMIN ..."
  inde on righ(TERMIN,4) +subs(TERMIN,4,2) +left(TERMIN,2) ;
       tag TERMIN   of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky ZDROJ ..."
  inde on ZDROJ    tag ZDROJ    of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky KONTAKT ..."
  inde on KONTAKT  tag KONTAKT  of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky S ..."
  inde on S        tag S        of (PR_ZDR+"DATA\INFOIDX")
  ? "   - Index polozky K ..."
  inde on K        tag K        of (PR_ZDR+"DATA\INFOIDX")
  use
  *-----*
  ? "   Vynaz puvodni nastavene databaze ..."
  dele file (PR_ZDR+"DATA\"+PR_JMZ+".DBF")
  dele file (PR_ZDR+"DATA\"+PR_JMZ+".FPT")
  dele file (PR_ZDR+"DATA\"+PR_JMZ+".CDX")
  ? "   Prejmenovani docasne databaze na puvodni..."
  rena (PR_ZDR+"DATA\INFOIDX.DBF") to ;
  (PR_ZDR+"DATA\"+PR_JMZ+".DBF")
  rena (PR_ZDR+"DATA\INFOIDX.FPT") to ;
  (PR_ZDR+"DATA\"+PR_JMZ+".FPT")
  rena (PR_ZDR+"DATA\INFOIDX.CDX") to ;
  (PR_ZDR+"DATA\"+PR_JMZ+".CDX")
  clos data
  ? "   Vznikl novy index *.CDX , konec " +dtoc(date()) +" "+time()
  ?
  *-----*
  wait " KONEC " wind
  rele wind WR
  *-----*
  =SYS(2002,1)
  @ 23,0 say RAD_23
retu
*
*: EOF: INFOR.PRG
